#ifndef QCARDBUTTON_H
#define QCARDBUTTON_H

#include <QPushButton>
#include "memory.h"

class CardButton : public QPushButton
{
	Q_OBJECT

public:
	CardButton(QWidget *parent, unsigned cardPosition);

	unsigned cardPosition() const; //const at the end means this function cannot modify class members.

private:
	unsigned m_cardPosition;
};

#endif // QCARDBUTTON_H
