#include "mainwindow.h"
#include "ui_mainwindow.h"


//static Agence * agence0 = new Agence(0);

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

   //每新增一个agence ui控件增加一个
    //创建新agence只能从agence1开始；
    Agence agence1 = Agence(1);
    ui->comboBoxAgence->addItem(QString::asprintf("Agence %d",agence1.getIdAgence()));
    agence1.initAgence();
    this->listAgence.push_back(agence1);

    Agence agence2 = Agence(2);
    ui->comboBoxAgence->addItem(QString::asprintf("Agence %d",agence2.getIdAgence()));
    agence2.initAgence();
    this->listAgence.push_back(agence2);

    Agence agence3 = Agence(3);
    ui->comboBoxAgence->addItem(QString::asprintf("Agence %d",agence3.getIdAgence()));
     agence3.initAgence();
    this->listAgence.push_back(agence3);

     Agence agence4 = Agence(4);
    ui->comboBoxAgence->addItem(QString::asprintf("Agence %d",agence4.getIdAgence()));
     agence4.initAgence();
    this->listAgence.push_back(agence4);

     Agence agence5 = Agence(5);
    ui->comboBoxAgence->addItem(QString::asprintf("Agence %d",agence5.getIdAgence()));
     agence5.initAgence();
    this->listAgence.push_back(agence5);

     paintBarVolumeCanal1(Agence(0),1,0);
     paintBarVolumeCanal2(Agence(0),2,0);
     paintBarVolumeCanal3(Agence(0),3,0);
     ui->volume->setChecked(true);
     ui->volume_2->setChecked(true);
     ui->volume_3->setChecked(true);
    //int testkk = getVolumeAllWeekPerAgence(Agence(0),1,2);

    //std::cout<<"test kk get volumeallweekperagence when agence0 "<< testkk <<std::endl;
  
    //std::cout<<"All id produit "<<1<<" of canal "<<1<<"at semaine "<<1<<" = "<<this->getVolumeTous(1,1,1)<<std::endl;

          //std::cout<<"produit"<<1<<" dans agence 1 canal 1  "<<" of "<<"all week "<<getVolumeAllWeekPerAgence(agence1,1,1)<<std::endl;
    
//////////////////QT STYLESHEET/////////////////////////
    setWindowTitle("BANQUE SUPERVISOR");
    QPalette pal = qApp->palette();
    pal.setColor(QPalette::Window, QRgb(0xf0f0f0));
    pal.setColor(QPalette::WindowText, QRgb(0x404044));
    qApp->setPalette(pal);
  

}



MainWindow::~MainWindow()
{
    delete ui;
}


Agence MainWindow::getListAgence(int index){
   //根据semaineCombobox的index选择返回列表里的agence  index对应的是listAgence里的idAgence
   //agence1 id=1 但是在列表中是0位
   //agence2 id=2 但是在列表中是1位
   //agence3 id=3 但是在列表中是2位
  
    for(unsigned int i = 0; i < this->listAgence.size();i++){
        if(this->listAgence[i].idAgence==index)
            return listAgence[i];
    }

}

float MainWindow::getEuroTous(int idProduit,int typeCanal,int semaine){
    float counter = 0.;
    
    switch(typeCanal)
      {
      case 1 :
            for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBanque.order.size();j++){
                  if(this->listAgence[i].canalBanque.order[j].id == idProduit  &&  this->listAgence[i].canalBanque.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalBanque.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

    case 2 :

       for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalAssurance.order.size();j++){
                  if(this->listAgence[i].canalAssurance.order[j].id == idProduit  &&  this->listAgence[i].canalAssurance.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalAssurance.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      case 3 :
        for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBoursier.order.size();j++){
                  if(this->listAgence[i].canalBoursier.order[j].id == idProduit  &&  this->listAgence[i].canalBoursier.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalBoursier.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      default :
             std::cout << "canal choisir existe pas" << std::endl;
      }

    return counter;

}
int MainWindow::getVolumeTous(int idProduit,int typeCanal,int semaine){//通过对list进行遍历 来找出 agence0（所有agence 的 指定产品id 指定typeCanal 指定week数）的综合
    int counter = 0;

    switch(typeCanal)
      {
      case 1 :
            for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBanque.order.size();j++){
                  if(this->listAgence[i].canalBanque.order[j].id == idProduit  &&  this->listAgence[i].canalBanque.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalBanque.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

    case 2 :

       for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalAssurance.order.size();j++){
                  if(this->listAgence[i].canalAssurance.order[j].id == idProduit  &&  this->listAgence[i].canalAssurance.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalAssurance.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      case 3 :
        for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBoursier.order.size();j++){
                  if(this->listAgence[i].canalBoursier.order[j].id == idProduit  &&  this->listAgence[i].canalBoursier.order[j].semaine  == semaine){
                    counter+=this->listAgence[i].canalBoursier.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      default :
             std::cout << "canal choisir existe pas" << std::endl;
      }
   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine <<" = "<<counter<<std::endl;
    return counter;
}

void MainWindow::on_comboBoxAgence_currentIndexChanged(int index)
{if(index == 0){//Agence 是tous时
        if (ui->volume->isChecked()){//##canal1
        paintBarVolumeCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro->isChecked()){
        paintBarEuroCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage->isChecked()){
        paintPieVolumeCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
        }
        if (ui->volume_2->isChecked()){//##canal2
         paintBarVolumeCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro_2->isChecked()){
        paintBarEuroCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage_2->isChecked()){
        paintPieVolumeCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
        }
        if (ui->volume_3->isChecked()){//##canal3
         paintBarVolumeCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro_3->isChecked()){
        paintBarEuroCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage_3->isChecked()){
        paintPieVolumeCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
        }
    }else{
              if (ui->volume->isChecked()){//##canal1
        paintBarVolumeCanal1(this->getListAgence(index),1,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro->isChecked()){
        paintBarEuroCanal1(this->getListAgence(index),1,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage->isChecked()){
        paintPieVolumeCanal1(this->getListAgence(index),1,ui->comboBoxSemaine->currentIndex());
        }
        if (ui->volume_2->isChecked()){//##canal2
         paintBarVolumeCanal2(this->getListAgence(index),2,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro_2->isChecked()){
        paintBarEuroCanal2(this->getListAgence(index),2,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage_2->isChecked()){
        paintPieVolumeCanal2(this->getListAgence(index),2,ui->comboBoxSemaine->currentIndex());
        }
        if (ui->volume_3->isChecked()){//##canal3
         paintBarVolumeCanal3(this->getListAgence(index),3,ui->comboBoxSemaine->currentIndex());
        }else if(ui->euro_3->isChecked()){
        paintBarEuroCanal3(this->getListAgence(index),3,ui->comboBoxSemaine->currentIndex());
        }else if(ui->percentage_3->isChecked()){
        paintPieVolumeCanal3(this->getListAgence(index),3,ui->comboBoxSemaine->currentIndex());
        }
        /*
    paintBarVolumeCanal1(this->getListAgence(index),1,ui->comboBoxSemaine->currentIndex());
    paintBarVolumeCanal2(this->getListAgence(index),2,ui->comboBoxSemaine->currentIndex());
    paintBarVolumeCanal3(this->getListAgence(index),3,ui->comboBoxSemaine->currentIndex());*/
    }
}



void MainWindow::on_comboBoxSemaine_currentIndexChanged(int weekIndex)
{   
    if(ui->comboBoxAgence->currentIndex() == 0){
          on_comboBoxAgence_currentIndexChanged(0);
 
        }else{//问题出现在这 因为getListAgence根本就没规定面对gagence id=0的时候该做什么
        if (ui->volume->isChecked()){//##canal1
        paintBarVolumeCanal1(this->getListAgence(ui->comboBoxAgence->currentIndex()),1,weekIndex);
        }else if(ui->euro->isChecked()){
        paintBarEuroCanal1(this->getListAgence(ui->comboBoxAgence->currentIndex()),1,weekIndex);
        }else if(ui->percentage->isChecked()){
        paintPieVolumeCanal1(this->getListAgence(ui->comboBoxAgence->currentIndex()),1,weekIndex);
        }
        if (ui->volume_2->isChecked()){//##canal2
         paintBarVolumeCanal2(this->getListAgence(ui->comboBoxAgence->currentIndex()),2,weekIndex);
        }else if(ui->euro_2->isChecked()){
        paintBarEuroCanal2(this->getListAgence(ui->comboBoxAgence->currentIndex()),2,weekIndex);
        }else if(ui->percentage_2->isChecked()){
        paintPieVolumeCanal2(this->getListAgence(ui->comboBoxAgence->currentIndex()),2,weekIndex);
        }
        if (ui->volume_3->isChecked()){//##canal3
        paintBarVolumeCanal3(this->getListAgence(ui->comboBoxAgence->currentIndex()),3,weekIndex);
        }else if(ui->euro_3->isChecked()){
        paintBarEuroCanal3(this->getListAgence(ui->comboBoxAgence->currentIndex()),3,weekIndex);
        }else if(ui->percentage_3->isChecked()){
        paintPieVolumeCanal3(this->getListAgence(ui->comboBoxAgence->currentIndex()),3,weekIndex);
        }
        /*
        paintBarVolumeCanal1(this->getListAgence(ui->comboBoxAgence->currentIndex()),1,weekIndex);
        paintBarVolumeCanal2(this->getListAgence(ui->comboBoxAgence->currentIndex()),2,weekIndex);
        paintBarVolumeCanal3(this->getListAgence(ui->comboBoxAgence->currentIndex()),3,weekIndex);*/
        }
}


int MainWindow::getVolumeAllWeekPerAgence(Agence a,int typeCanal,int idProduit)//通过输入 agence 的 canal类型 和 id produit的类型 //返回这个agence0 有多少有多少这个idproduit 在这个canal里
{
 int counter = 0;

if(a.idAgence == 0){//agenceid ==0 代表tous 直接丢出总值

     switch(typeCanal){
      case 1 :
            for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBanque.order.size();j++){
                  if(this->listAgence[i].canalBanque.order[j].id == idProduit){
                    counter+=this->listAgence[i].canalBanque.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

    case 2 :

       for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalAssurance.order.size();j++){
                  if(this->listAgence[i].canalAssurance.order[j].id == idProduit){
                    counter+=this->listAgence[i].canalAssurance.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      case 3 :
        for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBoursier.order.size();j++){
                  if(this->listAgence[i].canalBoursier.order[j].id == idProduit ){
                    counter+=this->listAgence[i].canalBoursier.order[j].volume;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      default :
             std::cout << "canal choisir existe pas" << std::endl;
      }

            }else{
                    switch(typeCanal)
                    {
                    case 1 :
                        
                                for(unsigned int i = 0;i < a.canalBanque.order.size();i++){
                                if(a.canalBanque.order[i].id == idProduit){
                                counter +=  a.canalBanque.order[i].volume;
                                }
                                }
                            
                            break;

                    case 2 :

                        for(unsigned int i = 0;i < a.canalAssurance.order.size();i++){
                                if(a.canalAssurance.order[i].id == idProduit){
                                counter +=  a.canalAssurance.order[i].volume;
                                }
                                }
                            
                            break;

                    case 3 :

                            for(unsigned int i = 0;i < a.canalBoursier.order.size();i++){
                                if(a.canalBoursier.order[i].id == idProduit){
                                counter +=  a.canalBoursier.order[i].volume;
                                }
                                }
                            
                            break;

                    default :
                            std::cout << "canal choisir existe pas" << std::endl;
                    }
  
   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine <<" = "<<counter<<std::endl;
   
  }

   return counter;
}
int MainWindow::getEuroAllWeekPerAgence(Agence a,int typeCanal,int idProduit)//通过输入 agence 的 canal类型 和 id produit的类型 //返回这个agence0 有多少有多少这个idproduit 在这个canal里
{
 float counter = 0;

if(a.idAgence == 0){//agenceid ==0 代表tous 直接丢出总值

     switch(typeCanal){
      case 1 :
            for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBanque.order.size();j++){
                  if(this->listAgence[i].canalBanque.order[j].id == idProduit){
                    counter+=this->listAgence[i].canalBanque.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

    case 2 :

       for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalAssurance.order.size();j++){
                  if(this->listAgence[i].canalAssurance.order[j].id == idProduit){
                    counter+=this->listAgence[i].canalAssurance.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      case 3 :
        for(unsigned int i = 0;i < this->listAgence.size();i++){
                for(unsigned int j = 0;j < this->listAgence[i].canalBoursier.order.size();j++){
                  if(this->listAgence[i].canalBoursier.order[j].id == idProduit ){
                    counter+=this->listAgence[i].canalBoursier.order[j].prix;
                  }
                   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine<<" has added "<<this->listAgence[i].canalBanque.order[].volume<<std::endl ;
                }
            }
            break;

      default :
             std::cout << "canal choisir existe pas" << std::endl;
      }

            }else{
                    switch(typeCanal)
                    {
                    case 1 :
                        
                                for(unsigned int i = 0;i < a.canalBanque.order.size();i++){
                                if(a.canalBanque.order[i].id == idProduit){
                                counter +=  a.canalBanque.order[i].prix;
                                }
                                }
                            
                            break;

                    case 2 :

                        for(unsigned int i = 0;i < a.canalAssurance.order.size();i++){
                                if(a.canalAssurance.order[i].id == idProduit){
                                counter +=  a.canalAssurance.order[i].prix;
                                }
                                }
                            
                            break;

                    case 3 :

                            for(unsigned int i = 0;i < a.canalBoursier.order.size();i++){
                                if(a.canalBoursier.order[i].id == idProduit){
                                counter +=  a.canalBoursier.order[i].prix;
                                }
                                }
                            
                            break;

                    default :
                            std::cout << "canal choisir existe pas" << std::endl;
                    }
  
   // std::cout<<"id produit "<<idProduit<<" of canal "<<typeCanal<<"at semaine "<<semaine <<" = "<<counter<<std::endl;
   
  }

   return counter;
}

void MainWindow::on_volume_clicked()
{
  if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintBarVolumeCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
  }else{
    paintBarVolumeCanal1(getListAgence(ui->comboBoxAgence->currentIndex()),1,ui->comboBoxSemaine->currentIndex());
  }
}

void MainWindow::on_volume_2_clicked()
{
    if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
       paintBarVolumeCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
    }else{
      paintBarVolumeCanal2(getListAgence(ui->comboBoxAgence->currentIndex()),2,ui->comboBoxSemaine->currentIndex());
    }
}

void MainWindow::on_volume_3_clicked()
{
    if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
       paintBarVolumeCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
    }else{
      paintBarVolumeCanal3(getListAgence(ui->comboBoxAgence->currentIndex()),3,ui->comboBoxSemaine->currentIndex());
    }
}

void MainWindow::paintBarVolumeCanal1(Agence agen,int idCanal,int week){
    QBarSet *set0 = new QBarSet("Volume");
    if(week == 0){//week = 0时 代表计算的是所有week的总数量
       *set0 << getVolumeAllWeekPerAgence(agen,idCanal,1)<<getVolumeAllWeekPerAgence(agen,idCanal,2)<<getVolumeAllWeekPerAgence(agen,idCanal,3)<<getVolumeAllWeekPerAgence(agen,idCanal,4);
    }else{
        if(agen.idAgence <= 0){
        *set0 << getVolumeTous(1,idCanal,week)<<getVolumeTous(2,idCanal,week) << getVolumeTous(3,idCanal,week) <<getVolumeTous(4,idCanal,week);
        }else{
        *set0 << agen.getVolume(1,idCanal,week)<<agen.getVolume(2,idCanal,week) << agen.getVolume(3,idCanal,week) <<agen.getVolume(4,idCanal,week);
        }
    }
   //![1]
   //再把一根一根的柱子加到柱子的列当中QBarSeries，
   //![2]把数据加载到数据列表中
       QBarSeries *series = new QBarSeries();
       series->append(set0);
   //![2]

   //![3]初始化画笔
       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Banquier");
       chart->setAnimationOptions(QChart::SeriesAnimations);
   //![3]
   //那么柱状图机画好了，可是没有x、y轴啊
   //所有还需要为QChart和QBarSeries设置x、y轴。那么就完成了。具体实现如下：
   //![4]为QChart和QBarSeries设置坐标轴
       QStringList categories;
       categories << "pret" << "compte" << "chequier" << "carte";
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
       //axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);
   //![4]

   //![5]设置图标的标题属性
       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);
   //![5]

   //![6]设置画布
       //QChartView *chartView = new QChartView(chart);
         ui->graphicsView_2->setChart(chart);
       ui->graphicsView_2->setRenderHint(QPainter::Antialiasing);

}
void MainWindow::paintBarVolumeCanal2(Agence agen,int idCanal,int week){
    
    QBarSet *set0 = new QBarSet("volume");
    if(week == 0){
      *set0 << getVolumeAllWeekPerAgence(agen,idCanal,1)<<getVolumeAllWeekPerAgence(agen,idCanal,2);
    }else{
    if(agen.idAgence <= 0){
      *set0 << getVolumeTous(1,idCanal,week)<<getVolumeTous(2,idCanal,week);
    }else{
       *set0 << agen.getVolume(1,idCanal,week)<<agen.getVolume(2,idCanal,week);
      }
      }
       QBarSeries *series = new QBarSeries();
       series->append(set0);

       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Assurance");
       chart->setAnimationOptions(QChart::SeriesAnimations);

       QStringList categories;
       categories << "vélo" << "immobilier";
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
       //axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);

       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);

       ui->viewCanalAssurance->setChart(chart);
       ui->viewCanalAssurance->setRenderHint(QPainter::Antialiasing);

}
void MainWindow::paintBarVolumeCanal3(Agence agen,int idCanal,int week){
    QBarSet *set0 = new QBarSet("volume");
     if(week == 0){
      *set0 << getVolumeAllWeekPerAgence(agen,idCanal,1);//getVolumeAllWeekPerAgence就是用来算指定agence一个季度 指定canal 指定idProduit的 销售额
    }else{
    if(agen.idAgence <= 0){//当指定agen0 Vector的时候
      *set0 << getVolumeTous(1,idCanal,week);//getVolumeTous通过遍历这个<agence>Vector
    }else{//其他agence
       *set0 << agen.getVolume(1,idCanal,week);
    }
    }
       QBarSeries *series = new QBarSeries();
       series->append(set0);

       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Boursier");
       chart->setAnimationOptions(QChart::SeriesAnimations);

       QStringList categories;
       categories << "notre action" ;
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
       //axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);

       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);

        ui->viewCanalBourse->setChart(chart);
        ui->viewCanalBourse->setRenderHint(QPainter::Antialiasing);

}

void MainWindow::paintBarEuroCanal1(Agence agen,int idCanal,int week){
    QBarSet *set0 = new QBarSet("Selling amount in euros");
    if(week == 0){//week = 0时 代表计算的是所有week的总数量
       *set0 << getEuroAllWeekPerAgence(agen,idCanal,1)<<getEuroAllWeekPerAgence(agen,idCanal,2)<<getEuroAllWeekPerAgence(agen,idCanal,3)<<getEuroAllWeekPerAgence(agen,idCanal,4);
    }else{
        if(agen.idAgence <= 0){
        *set0 << getEuroTous(1,idCanal,week)<<getEuroTous(2,idCanal,week) << getEuroTous(3,idCanal,week) <<getEuroTous(4,idCanal,week);
        }else{
        *set0 << agen.getEuro(1,idCanal,week)<<agen.getEuro(2,idCanal,week) << agen.getEuro(3,idCanal,week) <<agen.getEuro(4,idCanal,week);
        }
    }
   //![1]
   //再把一根一根的柱子加到柱子的列当中QBarSeries，
   //![2]把数据加载到数据列表中
       QBarSeries *series = new QBarSeries();
       series->append(set0);
   //![2]

   //![3]初始化画笔
       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Banquier");
       chart->setAnimationOptions(QChart::SeriesAnimations);
   //![3]
   //那么柱状图机画好了，可是没有x、y轴啊
   //所有还需要为QChart和QBarSeries设置x、y轴。那么就完成了。具体实现如下：
   //![4]为QChart和QBarSeries设置坐标轴
       QStringList categories;
       categories << "pret" << "compte" << "chequier" << "carte";
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
       //axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);
   //![4]

   //![5]设置图标的标题属性
       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);
   //![5]

   //![6]设置画布
       //QChartView *chartView = new QChartView(chart);
         ui->graphicsView_2->setChart(chart);
       ui->graphicsView_2->setRenderHint(QPainter::Antialiasing);

}
void MainWindow::paintBarEuroCanal2(Agence agen,int idCanal,int week){
    
    QBarSet *set0 = new QBarSet("selling amout in euros");
    if(week == 0){
      *set0 << getEuroAllWeekPerAgence(agen,idCanal,1)<<getEuroAllWeekPerAgence(agen,idCanal,2);
    }else{
    if(agen.idAgence <= 0){
      *set0 << getEuroTous(1,idCanal,week)<<getEuroTous(2,idCanal,week);
    }else{
       *set0 << agen.getEuro(1,idCanal,week)<<agen.getEuro(2,idCanal,week);
      }
      }
       QBarSeries *series = new QBarSeries();
       series->append(set0);

       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Assurance");
       chart->setAnimationOptions(QChart::SeriesAnimations);

       QStringList categories;
       categories << "vélo" << "immobilier";
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
       //axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);

       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);

       ui->viewCanalAssurance->setChart(chart);
       ui->viewCanalAssurance->setRenderHint(QPainter::Antialiasing);

}
void MainWindow::paintBarEuroCanal3(Agence agen,int idCanal,int week){
    QBarSet *set0 = new QBarSet("Selling amout in euros");
     if(week == 0){
      *set0 << getEuroAllWeekPerAgence(agen,idCanal,1);//getVolumeAllWeekPerAgence就是用来算指定agence一个季度 指定canal 指定idProduit的 销售额
    }else{
    if(agen.idAgence <= 0){//当指定agen0 Vector的时候
      *set0 << getEuroTous(1,idCanal,week);//getVolumeTous通过遍历这个<agence>Vector
    }else{//其他agence
       *set0 << agen.getEuro(1,idCanal,week);
    }
    }
       QBarSeries *series = new QBarSeries();
       series->append(set0);

       QChart *chart = new QChart();
       chart->addSeries(series);
       chart->setTitle("Canal Boursier");
       chart->setAnimationOptions(QChart::SeriesAnimations);

       QStringList categories;
       categories << "notre action" ;
       QBarCategoryAxis *axisX = new QBarCategoryAxis();//初始化X轴
       axisX->append(categories);
       chart->addAxis(axisX, Qt::AlignBottom);
       series->attachAxis(axisX);

       QValueAxis *axisY = new QValueAxis();//初始化Y轴
      // axisY->setRange(0,400);
       chart->addAxis(axisY, Qt::AlignLeft);
       series->attachAxis(axisY);

       chart->legend()->setVisible(true);
       chart->legend()->setAlignment(Qt::AlignBottom);

        ui->viewCanalBourse->setChart(chart);
        ui->viewCanalBourse->setRenderHint(QPainter::Antialiasing);

}

void MainWindow::on_euro_clicked()
{
  if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintBarEuroCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
  }else{
    paintBarEuroCanal1(getListAgence(ui->comboBoxAgence->currentIndex()),1,ui->comboBoxSemaine->currentIndex());
  }
}
void MainWindow::on_euro_2_released()
{
if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintBarEuroCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
  }else{
    paintBarEuroCanal2(getListAgence(ui->comboBoxAgence->currentIndex()),2,ui->comboBoxSemaine->currentIndex());
  }
}
void MainWindow::on_euro_3_released()
{
if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintBarEuroCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
  }else{
    paintBarEuroCanal3(getListAgence(ui->comboBoxAgence->currentIndex()),3,ui->comboBoxSemaine->currentIndex());
  }
}

void MainWindow::paintPieVolumeCanal1(Agence agen,int idCanal,int week)
{  
    QPieSeries *series = new QPieSeries();

    if(week == 0){//week = 0时 代表计算的是所有week的总数量
      series->append("pret", getVolumeAllWeekPerAgence(agen,idCanal,1));
      series->append("compte", getVolumeAllWeekPerAgence(agen,idCanal,2));
      series->append("chéquier", getVolumeAllWeekPerAgence(agen,idCanal,3));
      series->append("carte", getVolumeAllWeekPerAgence(agen,idCanal,4));
       //*set0 << getVolumeAllWeekPerAgence(agen,idCanal,1)<<getVolumeAllWeekPerAgence(agen,idCanal,2)<<getVolumeAllWeekPerAgence(agen,idCanal,3)<<getVolumeAllWeekPerAgence(agen,idCanal,4);
    }else{
        if(agen.idAgence <= 0){
            series->append("pret", getVolumeTous(1,idCanal,week));
            series->append("compte", getVolumeTous(2,idCanal,week));
            series->append("chéquier", getVolumeTous(3,idCanal,week));
            series->append("carte", getVolumeTous(4,idCanal,week));
        //*set0 << getVolumeTous(1,idCanal,week)<<getVolumeTous(2,idCanal,week) << getVolumeTous(3,idCanal,week) <<getVolumeTous(4,idCanal,week);
        }else{
            series->append("pret", agen.getVolume(1,idCanal,week));
            series->append("compte", agen.getVolume(2,idCanal,week));
            series->append("chéquier", agen.getVolume(3,idCanal,week));
            series->append("carte", agen.getVolume(4,idCanal,week));
        //*set0 << agen.getVolume(1,idCanal,week)<<agen.getVolume(2,idCanal,week) << agen.getVolume(3,idCanal,week) <<agen.getVolume(4,idCanal,week);
        }
    }

for(int i = 0;i < series->count();i++){
    QPieSlice *slice = series->slices().at(i);
    //slice->setExploded();
    slice->setLabelVisible();
    //slice->setPen(QPen(Qt::darkGreen, 2));
    //slice->setBrush(Qt::green);
}
    QChart *chart = new QChart();//创建新的Qchat实例
    chart->addSeries(series);//
    chart->setTitle(QString::fromLocal8Bit("volume pie chart"));
    chart->legend()->hide();
   //用于setChart显示刚刚绘制好的图
    ui->graphicsView_2->setRenderHint(QPainter::Antialiasing);
    ui->graphicsView_2->setChart(chart);

   /*//绘Spline图
    QSplineSeries *ser = new QSplineSeries();

    for (int i = 0; i < 100; i++)
    {
        ser->append(i, sin(0.5 * i) + 2 * i / (i + 1));
    }

    QChart *chart1 = new QChart();
    chart1->addSeries(ser);
    chart1->legend()->hide();
    chart1->createDefaultAxes();
    chart1->setTheme(QChart::ChartThemeBlueCerulean);

    ui->graphicsView_3->setChart(chart1);*/

}
void MainWindow::paintPieVolumeCanal2(Agence agen,int idCanal,int week)
{  
    QPieSeries *series = new QPieSeries();

    if(week == 0){//week = 0时 代表计算的是所有week的总数量
      series->append("vélo", getVolumeAllWeekPerAgence(agen,idCanal,1));
      series->append("immobilier", getVolumeAllWeekPerAgence(agen,idCanal,2));

       //*set0 << getVolumeAllWeekPerAgence(agen,idCanal,1)<<getVolumeAllWeekPerAgence(agen,idCanal,2)<<getVolumeAllWeekPerAgence(agen,idCanal,3)<<getVolumeAllWeekPerAgence(agen,idCanal,4);
    }else{
        if(agen.idAgence <= 0){
            series->append("vélo", getVolumeTous(1,idCanal,week));
            series->append("immobilier", getVolumeTous(2,idCanal,week));

        //*set0 << getVolumeTous(1,idCanal,week)<<getVolumeTous(2,idCanal,week) << getVolumeTous(3,idCanal,week) <<getVolumeTous(4,idCanal,week);
        }else{
            series->append("vélo", agen.getVolume(1,idCanal,week));
            series->append("immobilier", agen.getVolume(2,idCanal,week));

        //*set0 << agen.getVolume(1,idCanal,week)<<agen.getVolume(2,idCanal,week) << agen.getVolume(3,idCanal,week) <<agen.getVolume(4,idCanal,week);
        }
    }

for(int i = 0;i < series->count();i++){
    QPieSlice *slice = series->slices().at(i);
    //slice->setExploded();
    slice->setLabelVisible();
    //slice->setPen(QPen(Qt::darkGreen, 2));
    //slice->setBrush(Qt::green);
}
    QChart *chart = new QChart();//创建新的Qchat实例
    chart->addSeries(series);//
    chart->setTitle(QString::fromLocal8Bit("volume pie chart"));
    chart->legend()->hide();
   //用于setChart显示刚刚绘制好的图
    ui->viewCanalAssurance->setRenderHint(QPainter::Antialiasing);
    ui->viewCanalAssurance->setChart(chart);

   /*//绘Spline图
    QSplineSeries *ser = new QSplineSeries();

    for (int i = 0; i < 100; i++)
    {
        ser->append(i, sin(0.5 * i) + 2 * i / (i + 1));
    }

    QChart *chart1 = new QChart();
    chart1->addSeries(ser);
    chart1->legend()->hide();
    chart1->createDefaultAxes();
    chart1->setTheme(QChart::ChartThemeBlueCerulean);

    ui->graphicsView_3->setChart(chart1);*/

}
void MainWindow::paintPieVolumeCanal3(Agence agen,int idCanal,int week)
{  
    QPieSeries *series = new QPieSeries();

    if(week == 0){//week = 0时 代表计算的是所有week的总数量
      series->append("notre action", getVolumeAllWeekPerAgence(agen,idCanal,1));

       //*set0 << getVolumeAllWeekPerAgence(agen,idCanal,1)<<getVolumeAllWeekPerAgence(agen,idCanal,2)<<getVolumeAllWeekPerAgence(agen,idCanal,3)<<getVolumeAllWeekPerAgence(agen,idCanal,4);
    }else{
        if(agen.idAgence <= 0){
            series->append("notre action", getVolumeTous(1,idCanal,week));

        //*set0 << getVolumeTous(1,idCanal,week)<<getVolumeTous(2,idCanal,week) << getVolumeTous(3,idCanal,week) <<getVolumeTous(4,idCanal,week);
        }else{
            series->append("notre action", agen.getVolume(1,idCanal,week));
        //*set0 << agen.getVolume(1,idCanal,week)<<agen.getVolume(2,idCanal,week) << agen.getVolume(3,idCanal,week) <<agen.getVolume(4,idCanal,week);
        }
    }

for(int i = 0;i < series->count();i++){
    QPieSlice *slice = series->slices().at(i);
    //slice->setExploded();
    slice->setLabelVisible();
    //slice->setPen(QPen(Qt::darkGreen, 2));
    //slice->setBrush(Qt::green);
}
    QChart *chart = new QChart();//创建新的Qchat实例
    chart->addSeries(series);//
    chart->setTitle(QString::fromLocal8Bit("volume pie chart"));
    chart->legend()->hide();
   //用于setChart显示刚刚绘制好的图
    ui->viewCanalBourse->setRenderHint(QPainter::Antialiasing);
    ui->viewCanalBourse->setChart(chart);

   /*//绘Spline图
    QSplineSeries *ser = new QSplineSeries();

    for (int i = 0; i < 100; i++)
    {
        ser->append(i, sin(0.5 * i) + 2 * i / (i + 1));
    }

    QChart *chart1 = new QChart();
    chart1->addSeries(ser);
    chart1->legend()->hide();
    chart1->createDefaultAxes();
    chart1->setTheme(QChart::ChartThemeBlueCerulean);

    ui->graphicsView_3->setChart(chart1);*/

}


void MainWindow::on_percentage_clicked()
{
  if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintPieVolumeCanal1(Agence(0),1,ui->comboBoxSemaine->currentIndex());
  }else{
    paintPieVolumeCanal1(getListAgence(ui->comboBoxAgence->currentIndex()),1,ui->comboBoxSemaine->currentIndex());
  }
}

void MainWindow::on_percentage_2_clicked()
{
  if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintPieVolumeCanal2(Agence(0),2,ui->comboBoxSemaine->currentIndex());
  }else{
    paintPieVolumeCanal2(getListAgence(ui->comboBoxAgence->currentIndex()),2,ui->comboBoxSemaine->currentIndex());
  }
}

void MainWindow::on_percentage_3_clicked()
{
  if(ui->comboBoxAgence->currentIndex() == 0){//若这个按钮摁下时 agence按钮的index==0 那么直接传参Agence(0)
                                              
     paintPieVolumeCanal3(Agence(0),3,ui->comboBoxSemaine->currentIndex());
  }else{
    paintPieVolumeCanal3(getListAgence(ui->comboBoxAgence->currentIndex()),3,ui->comboBoxSemaine->currentIndex());
  }
}
