#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>


#include <QDebug>
#include <QCompleter>
#include <QStringList>
#include <QMovie>
#include <agence.h>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

#include <agence.h>
#include <canal.h>
#include <produit.h>
#include <iostream>
#include <QAbstractSeries>
#include <QtCharts>



class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

    void paintBarVolumeCanal1(Agence agen,int idCanal,int week);//画出该agence canalBanque 对应周数 的统计图 （最右边张图）
    void paintBarVolumeCanal2(Agence agen,int idCanal,int week);//画出该agence canalAssurance 对应周数 的统计图 （中间那张图）
    void paintBarVolumeCanal3(Agence agen,int idCanal,int week);//画出该agence canalBaanqier 对应周数 的统计图 （最左边那张图）
    float getEuroTous(int idProduit,int typeCanal,int semaine);//通过listAgence 指定idProduit 指定canal类型 指定周数 //来统计所有agence的销售额
    int getVolumeTous(int idProduit,int typeCanal,int semaine);//通过listAgence 指定idProduit 指定canal类型 指定周数 //来统计所有agence的销售量
    // void paintBar(Agence agen);
    int getVolumeAllWeekPerAgence(Agence a,int typeCanal,int idProduit);//返回 指定agence 指定canal 指定produit 所有周数的 销售量
    int getEuroAllWeekPerAgence(Agence a,int typeCanal,int idProduit);
    std::vector<Agence> listAgence;//每次初始化完一个agence 都会吧这个agence加入到这个vector 中 这个vector用于统计最后总体的总数量
    Agence getListAgence(int index);//从listAgence里通过 指定idAgence（Qcomboboxindex） 来找到这个列表里对应的agence
    void paintBarEuroCanal1(Agence agen,int idCanal,int week);
    void paintBarEuroCanal2(Agence agen,int idCanal,int week);
    void paintBarEuroCanal3(Agence agen,int idCanal,int week);
    void paintPieVolumeCanal1(Agence agen,int idCanal,int week);
    void paintPieVolumeCanal2(Agence agen,int idCanal,int week);
    void paintPieVolumeCanal3(Agence agen,int idCanal,int week);
private slots:
   // void on_SwitchTo_clicked();

    void on_comboBoxAgence_currentIndexChanged(int index);

    void on_comboBoxSemaine_currentIndexChanged(int index);

    void on_euro_clicked();

    void on_volume_clicked();

    void on_volume_2_clicked();

    void on_volume_3_clicked();

    void on_euro_2_released();

    void on_euro_3_released();

    void on_percentage_clicked();

    void on_percentage_2_clicked();

    void on_percentage_3_clicked();

private:
    Ui::MainWindow *ui;
};
#endif // MAINWINDOW_H
